"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var visitor_wrapper_1 = __importDefault(require("../utils/visitor-wrapper"));
var types_1 = require("@babel/types");
/**
 * `if (a == 1) a++` -> `if (a == 1) { a++ }`
 * @see https://eslint.org/docs/rules/curly
 */
exports.addCurlyBraces = visitor_wrapper_1.default({
    Loop: function (path) {
        var node = path.node;
        if (!types_1.isBlockStatement(node.body)) {
            node.body = types_1.blockStatement([node.body]);
        }
    },
    IfStatement: function (path) {
        var node = path.node;
        if (!types_1.isBlockStatement(node.consequent)) {
            node.consequent = types_1.blockStatement([node.consequent]);
        }
        if (node.alternate && !types_1.isBlockStatement(node.alternate) && !types_1.isIfStatement(node.alternate)) {
            node.alternate = types_1.blockStatement([node.alternate]);
        }
    },
});
exports.default = exports.addCurlyBraces;
