"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var visitor_wrapper_1 = __importDefault(require("../utils/visitor-wrapper"));
var types_1 = require("@babel/types");
/**
 * `!0` -> `true`, `!1` -> `false`
 * @see https://babeljs.io/docs/en/babel-plugin-transform-minify-booleans (reversed)
 */
exports.unminifyBooleans = visitor_wrapper_1.default({
    UnaryExpression: function (path) {
        var node = path.node;
        if (node.operator == "!" && types_1.isNumericLiteral(node.argument)) {
            var n = node.argument;
            switch (n.value) {
                case 0:
                    path.replaceWith(types_1.booleanLiteral(true));
                    break;
                case 1:
                    path.replaceWith(types_1.booleanLiteral(false));
                    break;
            }
        }
    },
});
exports.default = exports.unminifyBooleans;
