"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var visitor_wrapper_1 = __importDefault(require("../utils/visitor-wrapper"));
var types_1 = require("@babel/types");
/**
 * `a(), b()` -> `a(); b()`
 */
exports.unminifySequenceExpressions = visitor_wrapper_1.default({
    ExpressionStatement: function (path) {
        var node = path.node;
        if (types_1.isSequenceExpression(node.expression)) {
            var expressions = node.expression.expressions;
            path.replaceWithMultiple(expressions.map(function (e) {
                return types_1.expressionStatement(e);
            }));
        }
    },
    IfStatement: function (path) {
        var node = path.node;
        if (types_1.isSequenceExpression(node.test)) {
            var expressions = node.test.expressions;
            node.test = expressions.pop();
            expressions.forEach(function (e) {
                path.insertBefore(types_1.expressionStatement(e));
            });
        }
    },
});
exports.default = exports.unminifySequenceExpressions;
