"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var visitor_wrapper_1 = __importDefault(require("../utils/visitor-wrapper"));
var types_1 = require("@babel/types");
/**
 * @see https://babeljs.io/docs/en/babel-plugin-transform-merge-sibling-variables (reversed)
 * @see https://github.com/babel/minify/blob/master/packages/babel-plugin-minify-infinity/src/index.js
 */
exports.unminifyVariableDeclarations = visitor_wrapper_1.default({
    VariableDeclaration: function (path) {
        var node = path.node;
        var declarations = node.declarations;
        if (path.parent && types_1.isFor(path.parent)) {
            return;
        }
        if (declarations.length > 1) {
            path.replaceWithMultiple(declarations.map(function (d) {
                return types_1.variableDeclaration(node.kind, [
                    d,
                ]);
            }));
        }
    },
    ForStatement: function (path) {
        var node = path.node;
        if (types_1.isVariableDeclaration(node.init) && node.init.kind == "var") {
            var declarations = node.init.declarations;
            if (declarations.length > 1) {
                node.init.declarations = [declarations.pop()];
                path.insertBefore(types_1.variableDeclaration(node.init.kind, declarations));
            }
        }
    },
});
exports.default = exports.unminifyVariableDeclarations;
