import { Node } from "@babel/types";
import { Transformer, Visitor } from "./visitor-wrapper";
export declare const combineVisitors: (...visitors: Visitor[]) => Pick<import("@babel/traverse").Visitor<Node>, "AnyTypeAnnotation" | "ArgumentPlaceholder" | "ArrayExpression" | "ArrayPattern" | "ArrayTypeAnnotation" | "ArrowFunctionExpression" | "AssignmentExpression" | "AssignmentPattern" | "AwaitExpression" | "BigIntLiteral" | "BinaryExpression" | "LogicalExpression" | "BindExpression" | "BlockStatement" | "Program" | "TSModuleBlock" | "CatchClause" | "DoWhileStatement" | "ForInStatement" | "ForStatement" | "FunctionDeclaration" | "FunctionExpression" | "ObjectMethod" | "SwitchStatement" | "WhileStatement" | "ForOfStatement" | "ClassMethod" | "ClassPrivateMethod" | "BooleanLiteral" | "BooleanLiteralTypeAnnotation" | "BooleanTypeAnnotation" | "BreakStatement" | "CallExpression" | "ClassDeclaration" | "ClassExpression" | "ClassBody" | "ClassImplements" | "ClassPrivateProperty" | "ClassProperty" | "ContinueStatement" | "ReturnStatement" | "ThrowStatement" | "ConditionalExpression" | "IfStatement" | "DebuggerStatement" | "VariableDeclaration" | "ExportAllDeclaration" | "ExportDefaultDeclaration" | "ExportNamedDeclaration" | "ImportDeclaration" | "DeclareClass" | "DeclareFunction" | "DeclareInterface" | "DeclareModule" | "DeclareModuleExports" | "DeclareTypeAlias" | "DeclareOpaqueType" | "DeclareVariable" | "DeclareExportDeclaration" | "DeclareExportAllDeclaration" | "InterfaceDeclaration" | "OpaqueType" | "TypeAlias" | "TSDeclareFunction" | "TSInterfaceDeclaration" | "TSTypeAliasDeclaration" | "TSEnumDeclaration" | "TSModuleDeclaration" | "DeclaredPredicate" | "Decorator" | "Directive" | "DirectiveLiteral" | "DoExpression" | "EmptyStatement" | "EmptyTypeAnnotation" | "EnumBooleanBody" | "EnumNumberBody" | "EnumStringBody" | "EnumSymbolBody" | "EnumBooleanMember" | "EnumDeclaration" | "EnumDefaultedMember" | "EnumNumberMember" | "EnumStringMember" | "ExistsTypeAnnotation" | "ExportDefaultSpecifier" | "ExportNamespaceSpecifier" | "ExportSpecifier" | "Identifier" | "StringLiteral" | "NumericLiteral" | "NullLiteral" | "RegExpLiteral" | "MemberExpression" | "NewExpression" | "ObjectExpression" | "SequenceExpression" | "ParenthesizedExpression" | "ThisExpression" | "UnaryExpression" | "UpdateExpression" | "MetaProperty" | "Super" | "TaggedTemplateExpression" | "TemplateLiteral" | "YieldExpression" | "TypeCastExpression" | "JSXElement" | "JSXFragment" | "OptionalMemberExpression" | "PipelinePrimaryTopicReference" | "OptionalCallExpression" | "Import" | "TSAsExpression" | "TSTypeAssertion" | "TSNonNullExpression" | "ExpressionStatement" | "File" | "NullLiteralTypeAnnotation" | "FunctionTypeAnnotation" | "FunctionTypeParam" | "GenericTypeAnnotation" | "InferredPredicate" | "InterfaceExtends" | "InterfaceTypeAnnotation" | "IntersectionTypeAnnotation" | "MixedTypeAnnotation" | "NullableTypeAnnotation" | "NumberLiteralTypeAnnotation" | "NumberTypeAnnotation" | "ObjectTypeAnnotation" | "ObjectTypeInternalSlot" | "ObjectTypeCallProperty" | "ObjectTypeIndexer" | "ObjectTypeProperty" | "ObjectTypeSpreadProperty" | "QualifiedTypeIdentifier" | "StringLiteralTypeAnnotation" | "StringTypeAnnotation" | "ThisTypeAnnotation" | "TupleTypeAnnotation" | "TypeofTypeAnnotation" | "TypeAnnotation" | "TypeParameter" | "TypeParameterDeclaration" | "TypeParameterInstantiation" | "UnionTypeAnnotation" | "Variance" | "VoidTypeAnnotation" | "JSXAttribute" | "JSXClosingElement" | "JSXExpressionContainer" | "JSXSpreadChild" | "JSXOpeningElement" | "JSXText" | "JSXOpeningFragment" | "JSXClosingFragment" | "ImportDefaultSpecifier" | "ImportNamespaceSpecifier" | "ImportSpecifier" | "InterpreterDirective" | "JSXEmptyExpression" | "JSXIdentifier" | "JSXMemberExpression" | "JSXNamespacedName" | "JSXSpreadAttribute" | "RestElement" | "ObjectPattern" | "TSParameterProperty" | "LabeledStatement" | "Noop" | "ObjectProperty" | "PipelineBareFunction" | "PipelineTopicExpression" | "Placeholder" | "PrivateName" | "SpreadElement" | "TryStatement" | "WithStatement" | "TSImportEqualsDeclaration" | "TSExportAssignment" | "TSNamespaceExportDeclaration" | "SwitchCase" | "TSAnyKeyword" | "TSArrayType" | "TSBigIntKeyword" | "TSBooleanKeyword" | "TSCallSignatureDeclaration" | "TSConditionalType" | "TSConstructSignatureDeclaration" | "TSConstructorType" | "TSDeclareMethod" | "TSQualifiedName" | "TSEnumMember" | "TSExpressionWithTypeArguments" | "TSExternalModuleReference" | "TSFunctionType" | "TSImportType" | "TSIndexSignature" | "TSIndexedAccessType" | "TSInferType" | "TSInterfaceBody" | "TSIntersectionType" | "TSLiteralType" | "TSMappedType" | "TSMethodSignature" | "TSNeverKeyword" | "TSNullKeyword" | "TSNumberKeyword" | "TSObjectKeyword" | "TSOptionalType" | "TSParenthesizedType" | "TSPropertySignature" | "TSRestType" | "TSStringKeyword" | "TSSymbolKeyword" | "TSThisType" | "TSTupleType" | "TSUndefinedKeyword" | "TSUnknownKeyword" | "TSVoidKeyword" | "TSTypeReference" | "TSTypePredicate" | "TSTypeQuery" | "TSTypeLiteral" | "TSUnionType" | "TSTypeOperator" | "TSTypeAnnotation" | "TSTypeParameter" | "TSTypeParameterDeclaration" | "TSTypeParameterInstantiation" | "TemplateElement" | "V8IntrinsicIdentifier" | "VariableDeclarator" | "Expression" | "Statement" | "Declaration" | "Pattern" | "Binary" | "Scopable" | "BlockParent" | "Block" | "Terminatorless" | "CompletionStatement" | "Conditional" | "Loop" | "While" | "ExpressionWrapper" | "For" | "ForXStatement" | "Function" | "FunctionParent" | "Pureish" | "PatternLike" | "LVal" | "TSEntityName" | "Literal" | "Immutable" | "UserWhitespacable" | "Method" | "ObjectMember" | "Property" | "UnaryLike" | "Class" | "ModuleDeclaration" | "ExportDeclaration" | "ModuleSpecifier" | "Flow" | "FlowType" | "FlowBaseAnnotation" | "FlowDeclaration" | "FlowPredicate" | "EnumBody" | "EnumMember" | "JSX" | "Private" | "TSTypeElement" | "TSType">;
export declare const combineTransformers: (...transformers: Transformer[]) => Transformer;
export default combineTransformers;
